#include <stdio.h>
#include <stdlib.h>
#include "gtk/gtk.h"
#include "ai.h"
#include "gui.h"
#define VERBOSE
#define SINGLE 		1
#define MULTI  		2
#define GUI_CLIENT  25
#define gtk_button_set_label(w,l) gtk_label_set_text(GTK_LABEL(GTK_BIN(w)->child),l)
BOARD *brd;
int count;
int mode;
GtkWidget *list[27];
GtkWidget *entry;
char defstr[25];
GtkWidget *label1, *label2, *label3;
GtkWidget *window;
void init()
{
    if (brd)
	free(brd);
    brd = new_board();
    count = 0;
}

gint delete_event(GtkWidget * widget, GdkEvent * event, gpointer data)
{
    gtk_main_quit();
    return FALSE;
}

gint restart(GtkWidget * widget, gpointer data)
{
    int i;
    init();
    for (i = 0; i < 27; ++i)
	gtk_button_set_label(list[i], " ");
    sprintf(defstr, OPP_SCORE, 0);
    gtk_label_set_text((GtkLabel *) label1, defstr);
    sprintf(defstr, MY_SCORE, 0);
    gtk_label_set_text((GtkLabel *) label2, defstr);
    sprintf(defstr, "Whatever");
    gtk_label_set_text((GtkLabel *) label3, defstr);
#ifdef VERBOSE
    printf("Restarting...");
#endif
    return 1;
}

gint button_press(GtkWidget * widget, gpointer data)
{
    int d;
    int ms, os;
    ms = os = 0;
    if (count >= 26) {
	sprintf(defstr, "Over");
	gtk_label_set_text((GtkLabel *) label3, defstr);
	if (count > 26)
	    return TRUE;
    }
    if (brd[(int) data] == ' ') {
	gtk_button_set_label(widget, X_);
	brd[(int) data] = x_;
	count++;
	if (count < 27) {
	    d = decide(brd);
	    brd[d] = o_;
	    gtk_button_set_label(list[d], O_);
	    count++;
	}
	get_score(brd, &ms, &os);
	sprintf(defstr, OPP_SCORE, os);
	gtk_label_set_text((GtkLabel *) label1, defstr);
	sprintf(defstr, MY_SCORE, ms);
	gtk_label_set_text((GtkLabel *) label2, defstr);
    }
    return TRUE;
}

GtkWidget *make_table(int tab)
{
    GtkWidget *table;
    GtkWidget *button;
    int i, j, c;
    table = gtk_table_new(4, 3, TRUE);
    c = 0;
    for (i = 0; i < 3; ++i)
	for (j = 0; j < 3; ++j) {
	    button = gtk_button_new_with_label(" ");
	    gtk_signal_connect(GTK_OBJECT(button), "pressed",
			       GTK_SIGNAL_FUNC(button_press),
			       (gpointer) ((c++) + tab * 9));
	    list[(c - 1) + tab * 9] = button;
	    //printf("%i",c+tab*9);
	    gtk_table_attach(GTK_TABLE(table), button, j, j + 1, i, i + 1,
			     GTK_FILL | GTK_SHRINK | GTK_EXPAND,
			     GTK_FILL | GTK_SHRINK | GTK_EXPAND, 0, 0);
	    gtk_widget_show(button);
	}
    return table;
}

void gui_shutdown()
{
    delete_event(NULL, NULL, 0);
}

/*
int main(int argc,char **argv)
*/
int gui_init(int argc, char **argv)
{
    GtkWidget *button;
    GtkWidget *box1, *box2;
    //unsigned char *ii;
    //unsigned long l;
    int which, i;
    gtk_init(&argc, &argv);
    init();
    which = 1;
    mode = SINGLE;
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		       GTK_SIGNAL_FUNC(delete_event), NULL);
    gtk_container_set_border_width(GTK_CONTAINER(window), 1);
    box1 = gtk_vbox_new(FALSE, 0);

    /*create 'tables' */
    for (i = 0; i < 3; i++) {
	box2 = make_table(i);
	gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 0);
	gtk_widget_show(box2);
    }
    box2 = gtk_vbox_new(TRUE, 0);
    label1 = gtk_label_new(OPP_SCORE_INIT);
    label2 = gtk_label_new(MY_SCORE_INIT);
    label3 = gtk_label_new("Whatever");
    button = gtk_button_new_with_label("Restart");
    gtk_signal_connect(GTK_OBJECT(button), "pressed",
		       GTK_SIGNAL_FUNC(restart), NULL);
    gtk_box_pack_start(GTK_BOX(box2), label1, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(box2), label2, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(box2), label3, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(box2), button, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 0);
    gtk_widget_show(label1);
    gtk_widget_show(label2);
    gtk_widget_show(label3);
    gtk_widget_show(button);
    gtk_widget_show(box2);
    gtk_container_add(GTK_CONTAINER(window), box1);
    gtk_widget_show(button);
    gtk_widget_show(box1);
    gtk_widget_show(window);
    printf("All shown...whatever");
    gtk_main();
    return 0;
}
